from scrapy import log
from scrapy.exceptions import DropItem
from twisted.enterprise import adbapi

import time
import MySQLdb.cursors

from miracas.settings import *

'''
-SQL-
CREATE TABLE  `miracas`.`inkfruit_feed` (
`feedactivity_id` VARCHAR( 50 ) NOT NULL ,
`product_image_url` VARCHAR( 200 ) NOT NULL ,
`product_url` VARCHAR( 200 ) NOT NULL ,
`user_email` VARCHAR( 100 ) NOT NULL ,
`user_name` VARCHAR( 200 ) NOT NULL ,
`user_fbid` VARCHAR( 100 ) NOT NULL ,
`user_action` VARCHAR( 100 ) NOT NULL ,
`created_at` BIGINT NOT NULL
) ENGINE = MYISAM ;
'''

class MiracasMySQLPipeline(object):
    def __init__(self):
        self.dbpool = adbapi.ConnectionPool('MySQLdb',
                db=DB_NAME,
                user=DB_USER,
                passwd=DB_PASSWD,
                cursorclass=MySQLdb.cursors.DictCursor,
                charset='utf8',
                use_unicode=True
            )

    def process_item(self, item, spider):
        query = self.dbpool.runInteraction(self._conditional_insert, item)
        query.addErrback(self.handle_error)
        return item

    def _conditional_insert(self, tx, item):
        tx.execute("select * from inkfruit_feed where feedactivity_id = %s", (item['feedactivity_id'],))
        result = tx.fetchone()
        if result:
            raise DropItem("Item already stored in db: %s" % item)
        else:
            tx.execute(\
                "insert into inkfruit_feed (feedactivity_id, product_image_url,product_url,user_email,user_name,user_fbid,user_action, created_at) "
                "values (%s, %s, %s, %s, %s, %s, %s, %s)",
                (item['feedactivity_id'],
                 item['product_image_url'],
                 item['product_url'],
                 item['user_email'],
                 item['user_name'],
                 item['user_fbid'],
                 item['user_action'],
                 int(item['created_at']))
            )
            log.msg("Item stored in db: %s" % item, level=log.DEBUG)

    def handle_error(self, e):
        log.err(e)
